/*
 * Modifique o cdigo abaixo adicionando ou removendo a definio "virtual"
 * dos construtores.
 *
 * Observe e estude o comportamento exibido.
 *
 * Leitura recomendada do Herb Sutter: http://www.gotw.ca/publications/mill18.htm
 */

#include <iostream>

using namespace std;

class Base
{
public:
    Base() { cout << "Base: construtor" << endl; }
    /*virtual*/ ~Base() { cout << "Base: destrutor" << endl; }
};

class Derivada : public Base
{
public:
    Derivada() { cout << "Derivada: construtor" << endl; }
    /*virtual*/ ~Derivada() { cout << "Derivada: destrutor" << endl; }
};

int main()
{
    // Escopo 1
    {
        Derivada *d = new Derivada();
        delete d;
    }

    cout << endl;

    // Escopo 2
    {
        Derivada *d = new Derivada();
        delete static_cast<Base*>(d);
    }

    return 0;
}
